<?

$user_is_admin = user_access('administer '.GetModuleName());
$user_is_mod = user_access('moderate '.GetModuleName().'_'.UIE_ID('fid').'_'.GetModuleName());
$is_original_poster = $CurrentPost->Poster == $user->uid ? true : false;
$minused = time() - strtotime($CurrentPost->Posted);
$edit_expired = $minused > variable_get('forum_edit_timeout', 3600) ? true : false;
$user_can_post = user_access('post new threads/posts');

if
(
  //preliminary checks - 1 - is user an admin/mod
  (!$user_is_admin && !$user_is_mod)
  &&
  (
    //extra checks - 1 - is forum/thread locked - is edit time expired, can user actually post at all
    $CurrentForum->Locked || $CurrentThread->Locked || !$user_can_post
    ||
    (
      //extra checks - 2
      UIE_ID('PostID') && $CurrentPost && ($edit_expired || !$is_original_poster)
    )
  )
)
{
  drupal_access_denied();
  die();
}
else
{
/** Used to show the input form **/
  $SHOW_POST_INCLUDE = true;

  $CurrentThread = CurrentThread();
  if (form_get_errors() != null || ( (!UIE_ID('ThreadID') && !UIE_ID('fid')) || ((!UIE_ID('ThreadID') && UIE_ID('PostID')) || (!UIE_ID('ThreadID') && UIE_ID('QuoteID')))))
//    form_set_error('unreal.ie', t('Error, something is not quite right - please contact a site developer with this error.'));
    $Error = true;

  if (form_get_errors() == null && isset($_POST['NewPost']))
  {
     $ThreadTitle = GetPostTitle();
     $ThreadText = GetPostText();

     $timeout = variable_get('forum_newpost_timeout', 15);
     /** Post timer - can't post within 15 secs (for example) of the users's last post **/
     if(!$user_is_admin && !$user_is_mod && !IsEditPost() && $val = PostedTooSoon($timeout))
     {
       form_set_error('UIE_FORUM_FORM', t('Forum administrators require at least '.$timeout.' seconds between posts. You last posted '.$val.' seconds ago'));
     }
     elseif ((!UIE_ID('ThreadID') && !$ThreadID = CreateThread($ThreadTitle, $ThreadText, UIE_ID('fid'))) || (UIE_ID('PostID') && $thingy = EditPost(UIE_ID('PostID'), $ThreadTitle, $ThreadText, $user->uid, GetEditReason())) || (UIE_ID('ThreadID') && !UIE_ID('PostID') && !$NewPostID = AddPost(UIE_ID('ThreadID'),$ThreadTitle, $ThreadText)))
     {
       $ErrorMsg = 'Problem creating new ';
       $ErrorMsg .= UIE_ID('ThreadID') ? 'thread' : 'post';
       $ErrorMsg .= $thingy;
       form_set_error('UIE_FORUM_FORM', t($ErrorMsg));
     }
     else
       $SHOW_POST_INCLUDE = false;

     if($ThreadID)
       UIE_ID('ThreadID', $ThreadID);

     if(UIE_ID('ThreadID'))
       $CurrentThread = GetThread(UIE_ID('ThreadID'));
  }
  elseif (isset($_POST['PreviewPost']))
  {
    /** It's a preview **/
    if(form_get_errors() == null)
      $ForumTable .= "<div class=\"post-container\">".theme('table', null, DisplayPost(null, null, null, null, GetPostTitle(), GetPostText(), null, true, false, UIE_ID('fid')), array('id' => 'forum'))."</div>";
  }

  if($SHOW_POST_INCLUDE)
  {
    $bc_txt = UIE_ID('ThreadID') ? 'Reply' : 'New Thread';
    $bc_txt = UIE_ID('QuoteID') ? 'Reply (Quoted)' : $bc_txt;
    $bc_txt = UIE_ID('PostID') ? 'Edit Post' : $bc_txt;
    $breadcrumbs[] = t('<strong>[ %newval ]</strong>', array('%newval' => $bc_txt));
    drupal_set_title($bc_txt);

    if (!isset($textarea))
      $textarea = $PostText;

    if ((!isset($_POST['PreviewPost']) && !isset($_POST['NewPost'])) && (UIE_ID('QuoteID') || UIE_ID('PostID')))
    {
      if(UIE_ID('QuoteID')) $temp = "[quote=$QuotedPost->name]";
      $temp .= "$QuotedPost->Content";
      if(UIE_ID('QuoteID')) $temp .= "[/quote]\n";

      $textarea = $temp.$textarea;
    }
    include "post_include.php";
  }
  else
  {
    /** Post submitted successfully, so forward user to it **/
    drupal_goto(getThreadLinkTextLastPost($CurrentThread, null, false));
  }
}
